// sNZVF[_[̓
struct PS_INPUT
{
	float2 TexCoords0      : TEXCOORD0 ;    // eNX`W
	float3 VPosition       : TEXCOORD1 ;    // W( r[ )
	float3 VNormal         : TEXCOORD2 ;    // @( r[ )
} ;

// sNZVF[_[̏o
struct PS_OUTPUT
{
	float4 Color0          : SV_TARGET0 ;	// F
} ;


// }eAp[^
struct DX_D3D11_CONST_MATERIAL
{
	float4		Diffuse ;				// fBt[YJ[
	float4		Specular ;				// XyLJ[
	float4		Ambient_Emissive ;		// }eAG~bVuJ[ + }eAArGgJ[ * O[oArGgJ[

	float		Power ;					// XyL̋
	float		TypeParam0 ;			// }eA^Cvp[^0
	float		TypeParam1 ;			// }eA^Cvp[^1
	float		TypeParam2 ;			// }eA^Cvp[^2
} ;

// tHOp[^
struct DX_D3D11_VS_CONST_FOG
{
	float		LinearAdd ;				// tHOpp[^ end / ( end - start )
	float		LinearDiv ;				// tHOpp[^ -1  / ( end - start )
	float		Density ;				// tHOpp[^ density
	float		E ;						// tHOpp[^ Rΐ̒

	float4		Color ;					// J[
} ;

// Cgp[^
struct DX_D3D11_CONST_LIGHT
{
	int			Type ;					// Cg^Cv( DX_LIGHTTYPE_POINT Ȃ )
	int3		Padding1 ;				// pfBOP

	float3		Position ;				// W( r[ )
	float		RangePow2 ;				// L̂Q

	float3		Direction ;				// ( r[ )
	float		FallOff ;				// X|bgCgpFallOff

	float3		Diffuse ;				// fBt[YJ[
	float		SpotParam0 ;			// X|bgCgpp[^O( cos( Phi / 2.0f ) )

	float3		Specular ;				// XyLJ[
	float		SpotParam1 ;			// X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )

	float4		Ambient ;				// ArGgJ[ƃ}eÃArGgJ[Z

	float		Attenuation0 ;			// ɂ錸pp[^O
	float		Attenuation1 ;			// ɂ錸pp[^P
	float		Attenuation2 ;			// ɂ錸pp[^Q
	float		Padding2 ;				// pfBOQ
} ;

// sNZVF[_[E_VF[_[ʃp[^
struct DX_D3D11_CONST_BUFFER_COMMON
{
	DX_D3D11_CONST_LIGHT		Light[ 6 ] ;			// Cgp[^
	DX_D3D11_CONST_MATERIAL		Material ;				// }eAp[^
	DX_D3D11_VS_CONST_FOG		Fog ;					// tHOp[^
} ;

// 萔obt@sNZVF[_[{p[^
struct DX_D3D11_PS_CONST_BUFFER_BASE
{
	float4		FactorColor ;			// At@l

	float		MulAlphaColor ;			// J[ɃAt@lZ邩ǂ( 0.0f:ZȂ  1.0f:Z )
	float		AlphaTestRef ;			// At@eXgŎgprl
	float2		Padding1 ;

	int			AlphaTestCmpMode ;		// At@eXgr[h( DX_CMP_NEVER Ȃ )
	int3		Padding2 ;

	float4		IgnoreTextureColor ;	// eNX`J[pJ[
} ;

// _VF[_[EsNZVF[_[ʃp[^
cbuffer cbD3D11_CONST_BUFFER_COMMON					: register( b0 )
{
	DX_D3D11_CONST_BUFFER_COMMON		g_Common ;
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_PS_BASE				: register( b1 )
{
	DX_D3D11_PS_CONST_BUFFER_BASE		g_Base ;
} ;


// C++ Őݒ肷eNX`萔̒`
SamplerState g_DiffuseMapSampler            : register( s0 ) ;		// fBt[Y}bveNX`
Texture2D    g_DiffuseMapTexture            : register( t0 ) ;		// fBt[Y}bveNX`
SamplerState g_ToonDiffuseGradSampler       : register( s1 ) ;		// gD[_OpfBt[YJ[Of[VeNX`
Texture2D    g_ToonDiffuseGradTexture       : register( t1 ) ;		// gD[_OpfBt[YJ[Of[VeNX`


// main֐
PS_OUTPUT main( PS_INPUT PSInput )
{
	PS_OUTPUT PSOutput ;
	float4 lTextureDiffuseColor ;
	float3 lSpecularColor ;
	float3 lDiffuseColor ;
	float3 Normal ;
	float lDiffuseAngleGen ;
	float3 lTotalDiffuse ;
	float3 lTotalSpecular ;
	float3 lTotalAmbient ;
	float4 lToonColor ;
	float lTotalLightGen ;
	float3 V_to_Eye ;
	float3 TempF3 ;
	float Temp ;
	float3 lLightTemp ;
	float3 lLightDir ;


	// @̏
	Normal = normalize( PSInput.VNormal ) ;

	// _W王_ւ̃xNg𐳋K
	V_to_Eye = normalize( -PSInput.VPosition ) ;

	// fBt[YJ[ƃXyLJ[ƃArGgJ[̍vl
	lTotalDiffuse  = float3( 0.0f, 0.0f, 0.0f ) ;
	lTotalSpecular = float3( 0.0f, 0.0f, 0.0f ) ;
	lTotalAmbient  = float3( 0.0f, 0.0f, 0.0f ) ;

	// Cǧvl̏
	lTotalLightGen = 0.0f ;



	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// CgxNg̃Zbg
	lLightDir = g_Common.Light[ 0 ].Direction ;


	// fBt[YpxvZ
	lDiffuseAngleGen = saturate( dot( Normal, -lLightDir ) ) ;

	// fBt[YvlɉZ
	lTotalLightGen += lDiffuseAngleGen ;


	// XyLJ[vZ

	// n[txNǧvZ
	TempF3 = normalize( V_to_Eye - lLightDir ) ;

	// Temp = pow( max( 0.0f, N * H ), g_Common.Material.Power )
	Temp = pow( max( 0.0f, dot( Normal, TempF3 ) ), g_Common.Material.Power ) ;

	// XyLCgvl += XyLpxvZ * Cg̃XyLJ[
	lTotalSpecular += Temp * g_Common.Light[ 0 ].Specular ;


	// Cg̃fBt[YJ[vlɉZ
	lTotalDiffuse  += g_Common.Light[ 0 ].Diffuse ;

	// Cg̃ArGgJ[vlɉZ
	lTotalAmbient  += g_Common.Light[ 0 ].Ambient.xyz ;

	// fBNViCg̏ +++++++++++++++++++++++++++++++++++++++++++++++++++++( I )

	// ArGgJ[̒~ϒl += }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z
	lTotalAmbient += g_Common.Material.Ambient_Emissive.xyz ;








	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// eNX`J[̎擾
	lTextureDiffuseColor = g_DiffuseMapTexture.Sample( g_DiffuseMapSampler, PSInput.TexCoords0 ) ;

	// gD[eNX`J[Cg̃fBt[Y擾
	lToonColor = g_ToonDiffuseGradTexture.Sample( g_ToonDiffuseGradSampler, lTotalLightGen ) ;

	// fBt[YJ[ = Cg̃fBt[YJ[~ϒl * }eÃfBt[YJ[
	lDiffuseColor  = lTotalDiffuse  * g_Common.Material.Diffuse.xyz ;
	
	// XyLJ[ = Cg̃XyLJ[~ϒl * }eÃXyLJ[
	lSpecularColor = lTotalSpecular * g_Common.Material.Specular.xyz ;

	// o = saturate( saturate( fBt[YJ[ * ArGgJ[̒~ϒl ) * gD[eNX`J[ + XyLJ[ ) * eNX`J[
	PSOutput.Color0.rgb = saturate( saturate( lDiffuseColor + lTotalAmbient ) * lToonColor.rgb + lSpecularColor ) * lTextureDiffuseColor.rgb ;

	// At@l = fBt[YAt@ * }eÃfBt[YAt@ * sx
	PSOutput.Color0.a = lTextureDiffuseColor.a * g_Common.Material.Diffuse.a * g_Base.FactorColor.a ;

	// o̓J[vZ +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return PSOutput ;
}


